//
// Created by marcin on 06.06.16.
//

#ifndef HDCV_FRAME_H
#define HDCV_FRAME_H
//#include <opencv2/imgproc/imgproc.hpp>
#include <opencv2/opencv.hpp>
#include "FingerName.h"

using namespace cv;
using namespace std;


class Frame {
    public:
        Mat original;
        Mat hsv;
        Mat blackwhite;
        vector<vector<Point> > contours;
        vector<Point> fingerTips;
        Point cog;
        vector<FingerName> namedFingers;
        int contourAxisAngle;
     enum Colors{BLACK,WHITE,RED,GREEN,BLUE,CYAN,MAGENTA,YELLOW};
    static map<Colors,Scalar> colors;


    // defects data for the hand contour
    vector<Vec4i> hierarchy;

    static  int IMG_SCALE;
        static  int MAX_POINTS;
        static  int MIN_FINGER_DEPTH ;
        static  int MAX_D ;
        static  int MAX_FINGER_ANGLE ;
        static  int MIN_FINGER_ANGLE ;

 static  int MIN_THUMB;
 static  int MAX_THUMB;

 static  int MIN_INDEX;
 static  int MAX_INDEX;

    void compute(VideoCapture capture, int counter);
    int findBiggestContour(Mat &tempblackwhite) ;
    int calculateTilt(double m11, double m20, double m02);
    void reduceTips(vector<Point> startPts, vector<Point> endPts, vector<Point> farPts, vector<float> depths);

    Point extractContourInfo(vector<Point> points);
    void findFingerTips(int biggestContourIndex, int COUNTER);

    int angleBetween(Point start, Point far, Point end);

    void nameFingers(Point cogPt, int contourAxisAngle, vector<Point> fingerTips);

    vector<FingerName> labelThumbIndex(vector<Point> fingerTips, vector<FingerName> nms);

    int angleToCOG(Point tipPt, Point cogPt, int contourAxisAngle);
    void printFingers(String title, vector<FingerName> nms);

    vector<FingerName> labelUnknowns(vector<FingerName> nms);

    vector<FingerName> labelPrev(vector<FingerName> nms, int i, FingerName name);

    bool usedName(vector<FingerName> nms, FingerName name);

    vector<FingerName> labelFwd(vector<FingerName> nms, int i, FingerName name);
};


#endif //HDCV_FRAME_H
